;//--------------------------------
;//
;//--------------------------------
.include "m32def.inc" ; .device ATMega32

;//--------------------------------
.DSEG

.def temp=R16

.equ    LCD_PORT    = PORTD  ; PORTA
.equ    LCD_DDR     = DDRD   ; DDRA
.equ    LCD_PIN     = PIND   ; PINA

.equ    D0      = 0
.equ    D1      = 1
.equ    D2      = 2
.equ    D3      = 3
.equ    D4      = 4
.equ    D5      = 5
.equ    D6      = 6
.equ    D7      = 7

;//---------------------------------
;//-----------------------------------------------
.CSEG

.ORG $0000
    RJMP INIT

;// -------------------------------
INIT:
;    // ----------
    ldi r16,low(RAMend)
    out SPL,r16
    ldi r16,high(RAMend)
    out SPH,r16
;    //-----------------------------

;    // 
    RCALL LCD_INIT
STOP:
    sbi     LCD_PORT, D0
    RCALL   WAIT_1000us
    cbi     LCD_PORT, D0
    in      temp, PINC
    out     PORTB, temp

    sbi     LCD_PORT, D1
    RCALL   WAIT_1000us
    cbi     LCD_PORT, D1

    sbi     LCD_PORT, D2
    RCALL   WAIT_1000us
    cbi     LCD_PORT, D2

    sbi     LCD_PORT, D3
    RCALL   WAIT_1000us
    cbi     LCD_PORT, D3

    sbi     LCD_PORT, D4
    RCALL   WAIT_1000us
    cbi     LCD_PORT, D4

    sbi     LCD_PORT, D5
    RCALL   WAIT_1000us
    cbi     LCD_PORT, D5

    sbi     LCD_PORT, D6
    RCALL   WAIT_1000us
    cbi     LCD_PORT, D6

    sbi     LCD_PORT, D7
    RCALL   WAIT_1000us
    cbi     LCD_PORT, D7
    NOP
    RJMP STOP

;//------------------------------------------------
;//------------------------------------

;//---------------------------------
LCD_INIT:
    RCALL   WAIT_20ms

    cbi     DDRC, D0             ;    
    cbi     DDRC, D1
    cbi     DDRC, D2
    cbi     DDRC, D3
    cbi     DDRC, D4
    cbi     DDRC, D5
    cbi     DDRC, D6             ; PORTC
    cbi     DDRC, D7

    sbi     PORTC, D0             ;   C  
    sbi     PORTC, D1
    sbi     PORTC, D2
    sbi     PORTC, D3
    sbi     PORTC, D4
    sbi     PORTC, D5
    sbi     PORTC, D6             ;
    sbi     PORTC, D7

    sbi     DDRB, D0             ;    
    sbi     DDRB, D1
    sbi     DDRB, D2
    sbi     DDRB, D3
    sbi     DDRB, D4
    sbi     DDRB, D5
    sbi     DDRB, D6             ;
    sbi     DDRB, D7

    sbi     LCD_DDR, D0             ;    
    sbi     LCD_DDR, D1
    sbi     LCD_DDR, D2
    sbi     LCD_DDR, D3
    sbi     LCD_DDR, D4
    sbi     LCD_DDR, D5
    sbi     LCD_DDR, D6             ;
    sbi     LCD_DDR, D7

    cbi     LCD_PORT, D0            ;    ax
    cbi     LCD_PORT, D1
    cbi     LCD_PORT, D2
    cbi     LCD_PORT, D3
    cbi     LCD_PORT, D4
    cbi     LCD_PORT, D5
    cbi     LCD_PORT, D6
    cbi     LCD_PORT, D7

    RCALL   WAIT_100us
    RET



    LDI     temp, 0b00000011
    RCALL   One                     ; 
    RCALL   WAIT_100us
    LDI     temp, 0b00000011
    RCALL   One                     ;
    RCALL   WAIT_100us
    LDI     temp, 0b00000011
    RCALL   One                     ; 
    RCALL   WAIT_100us

    LDI     temp, 0b00000010        ;4x  
    RCALL   One
    RCALL   WAIT_100us

    LDI     temp, 0x28              ;2  57
    RCALL   Two
    RCALL   WAIT_100us

    LDI     temp, 0x06              ;  DDRAM
    RCALL   Two
    RCALL   WAIT_100us

    LDI     temp, 0x0c              ; ,  
    RCALL   Two
    RCALL   WAIT_100us

    LDI     temp, 0x01              ; LCD
    RCALL   Two
    RCALL   WAIT_5ms

    LDI     temp, 0x06              ; LCD
    RCALL   Two
    RCALL   WAIT_5ms
    RET


;//----------------------------------
WrData:
    CLR     R17                     ; R17
    SBR     R17, 0b00010000         ; 5   R17 (RS=1  )
    RJMP    TwoData
    RET


Two:                                    ;  
    CLR     R17
TwoData:
    PUSH    R16                         ;   
    SWAP    R16                         ;  
    ANDI    temp, 0b00001111            ;   
    OR      temp, R17                   ;     R17
    OUT     LCD_PORT, temp              ;    
    NOP
    NOP
    NOP

    SBI     LCD_PORT, D7                ; 
    NOP
    NOP
    NOP
    NOP
    NOP
    CBI     LCD_PORT, D7                ; 

    RCALL   WAIT_100us
    NOP
    POP     R16                         ;    
    ANDI    temp, 0b00001111            ;  
    OR      temp, R17                   ;  

One:
    OUT     LCD_PORT, temp              ;    
    NOP
    NOP
    NOP

    SBI     LCD_PORT, D7                ; 
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    CBI     LCD_PORT, D7                ; 
    RCALL   WAIT_100us                  ;

    RET



;//----------------------------------
;// 

    WAIT_20ms:
; =============================
;    delay loop generator
;     160000 cycles:
; -----------------------------
; delaying 159975 cycles:
          ldi  R17, $E1
WGLOOP01: ldi  R18, $EC
WGLOOP11: dec  R18
          brne WGLOOP11
          dec  R17
          brne WGLOOP01
; -----------------------------
; delaying 24 cycles:
          ldi  R17, $08
WGLOOP21: dec  R17
          brne WGLOOP21
; -----------------------------
; delaying 1 cycle:
          nop
; =============================
    RET

;//----------------------------------

WAIT_5ms:                               ;   
; =============================
;    delay loop generator
;     40000 cycles:
; -----------------------------
; delaying 39999 cycles:
          ldi  R17, $43
WGLOOP02: ldi  R18, $C6
WGLOOP12: dec  R18
          brne WGLOOP12
          dec  R17
          brne WGLOOP02
; -----------------------------
; delaying 1 cycle:
          nop
; =============================
    RET

;//----------------------------------
WAIT_1000us:
; =============================
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RCALL   WAIT_100us
    RET

;//----------------------------------
WAIT_100us:
; =============================
;    delay loop generator
;     800 cycles:
; -----------------------------
; delaying 798 cycles:
          ldi  R17, $02
WGLOOP03: ldi  R18, $84
WGLOOP13: dec  R18
          brne WGLOOP13
          dec  R17
          brne WGLOOP03
; -----------------------------
; delaying 2 cycles:
          nop
          nop
; =============================

    RET